REACT:    MOV R0,#KEYPR                 ; SET R0 TO KEYPR LOC.
          MOV R1,#PRGRN                 ; SET R1 TO 107 LOC FOR PROG / RUN MODE.
          MOV A,@R1                     ; READ STATUS.
          JNZ PRGMD                     ; IF NOT ZERO PROGMODE.
          MOV R1,#CALRN                 ; SET R1 TO 42 LOC FOR CAL IN RUN MODE.
          MOV A,@R1                     ; READ STATUS.
          JNZ CALMD                     ; IF NOT ZERO CALMODE.
RUNMD:    MOV A,@R0                     ; READ KEYPR.
          XRL A,#PRKEY                  ; IF BOTH < AND > KEY ARE PRESSED ZER.
          JZ SETMD                      ; IF ZERO SET MODE TO PROG.
          MOV A,@R0                     ; READ KEYPR.
          XRL A,#CLKEY                  ; IF BOTH '[]' AND 'O' KEY ARE PRESSED ZER.
          JZ CLMOD                      ; GOES TO CALIBRATION MODE PV DISPLAY AND ZERO CAL.
          JMP OTHER                     ; IF NOT CHECK FOR OTHER KEYPRESS.
SETMD:    MOV R1,#PRGRN                 ; SET R1 TO 107 LOC FOR PROG / RUN MODE.
          MOV @R1,#10000000B            ; SET PROG MODE IN LOC 107. ALSO GOOD FOR LED
          MOV R0,#DISPL                 ; LOC 104 DISPL HOLDS DISPLAY SELECT LOC 0 FOR PV
          MOV @R0,#0                    ; SET DISPL TO 0 TO SCROLL BCK AFTR 4 NO PV IN PRG MD.
          JMP SERVD                     ; KEY SERVICED.
CLMOD:    JNT0 CALST                    ; CALIBRATION MODE IN WHICH ZERO AND FS ARE SET.
          JMP SERVD                     ; IF T0 IS PULLED LOW KEY SERVED AS CAL JUMPER PRESENT.
CALST:    MOV @R1,#1                    ; SET PROG MODE IN LOC 107. ALSO GOOD FOR LED
          MOV R0,#DISPL                 ; SET R0 TO DISPL LOC.
          MOV @R0,#0                    ; SET DISPL TO PROCESS VALUE REQ DURING CAL.
          JMP SERVD                     ; AS CAL MODE IS SET RETURN.
OTHER:    MOV A,@R0                     ; READ KEYPR.
          JB5 RLYOF                     ; IF ACC BIT 5 IS 1 OFF BOTH RELAYS. KEY [] S1
          JB7 DSPSL                     ; IF ACC BIT 7 IS 1 INC DISPL LOC BY 1.KEY O S2
          JMP SERVD                     ; IF NO KEY PRESS OR <> KEY WAS PRESSED. < S3 S4 >
RLYOF:    JB4 L1OFF                     ; IF ACC BIT 4 IS 1 OFF L1 RELAY. KEY O+>
          JB6 L2OFF                     ; IF ACC BIT 6 IS 1 OFF L2 RELAY. KEY O+<
          JMP SERVD                     ; IF ONLY O KEY PRESSED DONT DO ANYTHING.
L1OFF:    MOV R0,#OPSP1                 ; SET R0 TO LOC 105 OF RAM OP SP1.
          MOV @R0,#1                    ; SET OUTPUT RELAY.
          CALL OUTP1                    ; CALLED OUTPUT TO SET OUTPUTS OFF.
          JMP SERVD                     ; KEY SERVED.
L2OFF:    MOV R0,#OPSP2                 ; SET R0 TO LOC 105 OF RAM OP SP1.
          MOV @R0,#1                    ; SET OUTPUT RELAY.
          CALL OUTP2                    ; CALLED OUTPUT TO SET OUTPUTS OFF.
          JMP SERVD                     ; KEY SERVED.
DSPSL:    CALL DISEL                    ; CALL ROUTINE TO SELECT DISPLAY.
          JMP SERVD                     ; KEY SERVED.
PRGMD:    MOV A,@R0                     ; READ KEYPR.
          JB7 DSPSP                     ; IF ACC BIT 7 IS 1 INC DISPL LOC BY 1.KEY O S2
          JMP IDCKY                     ; IF NOT JMP IDCKY.
DSPSP:    CALL DISEL                    ; CALL ROUTINE TO SELECT DISPLAY.
          JMP SERVD                     ; KEY SERVED.
IDCKY:    MOV R1,#DISPL                 ; SET R1 TO DISPL LOC.
          MOV A,@R1                     ; READ LOC DISPL FOR PRESENT REQ FOR DISPLAY.
          JZ SERVD                      ; IF IN DISPL=0 THEN DO NOT INC-DEC-ZER.
          ANL A,#SEGCD                  ; 0FH AND TO LOSE UPPER NIBBLE.
          ADD A,#MAPCD                  ; ADD TO ACC ADDR MAPCD
          MOVP3 A,@A                    ; READ PROG MEM LOCATION ADDR BY ACC TO FETCH MAP
          MOV R2,A                      ; KEEP POL POSITION IN R2.
          ADD A,#DVMNO                  ; ADD DVMNO TO GET LOCATION OF UNITS PLACE.
          MOV R5,A                      ; LOAD MAP LOCATION IN R5 IN UNITS PLACE.
          MOV R1,A                      ; LOAD MAP LOCATION IN R1 IN UNITS PLACE.
          MOV R0,#DISPL                 ; SET R0 TO DISPL LOC.
          MOV A,@R0                     ; READ DISPL PV NA IN PRG MODE.               001 SP1
          JB0 SPLMT                     ; JUMP TO SPLMT 3 DIGITS IF A BIT 0 IS SET    010 DB1
DBLMT:    MOV R7,#DVMNO-2               ; IF NOT THEN LIMIT DISPLAY TO 2 FOR DB.      011 SP2
          MOV R4,#DVMNO-2               ; AS DJNZ LOSES R7 VALUE R4 TEMP STORAGE      100 DB2
          JMP CONTD                     ; JUMP OVER AS R7 IS SET.
SPLMT:    MOV R7,#DVMNO-1               ; SET R7 TO 3 IF JB0 IS SET TO 1 .
          MOV R4,#DVMNO-1               ; STORAGE OF R7 VALUE.
CONTD:    CALL MPSET                    ; CALL MAP SET WHICH INC OR DEC SET MAP OR RESETS TO 0.
          JMP RMPSR                     ; KEY SERVED IN RAMP UP MODE.
CALMD:    MOV A,@R0                     ; READ KEYPR.
          JB7 DSPCL                     ; IF ACC BIT 4 IS 1 INC CALRN LOC BY 1.
          JMP IDOCL                     ; IF NOT JMP IDOCL.
DSPCL:    MOV A,@R1                     ; READ CALRN.
          INC A                         ; 1-CA,2-Lo,3-Hi.4-dP,5-TXT01,6-TXT02,7- GO BACK 1.
          XRL A,#9                      ; IT COMES HERE ONLY IF IT IS > 0.
          JZ LIMCL                      ; IF ZERO MAX DISPLAY COUNT REACHED.
          JMP WITCL                     ; IF NOT LESS THAN 5.
LIMCL:    MOV @R1,#1                    ; SET CALRN TO 1 TO SCROLL BACK AFTER 4.
          JMP SERVD                     ; KEY SERVED.
WITCL:    INC @R1                       ; INCREMENT CALRN BY 1.
          JMP SERVD                     ; KEY SERVED.
IDOCL:    MOV A,@R1                     ; READ CALRN.
          XRL A,#2                      ; IF CALRN=2 IE Lo THEN JMP TO ZECAL
          JZ ZECAL                      ; ZECAL SETS INC OR DEC ZERMP BUT DISPLAY PRVMP.
          MOV A,@R1                     ; READ CALRN.
          XRL A,#3                      ; IF CALRN=3 IE Hi THEN JMP TO FSCAL
          JZ FSCAL                      ; FSCAL SETS INC OR DEC HICAL BUT DISPLAY PRVMP.
          MOV A,@R1                     ; READ CALRN.
          XRL A,#4                      ; IF CALRN=4 IE dP THEN JMP TO DPCAL
          JZ DPCAL                      ; FSCAL SETS INC OR DEC HICAL BUT DISPLAY PRVMP.
          MOV A,@R1                     ; READ CALRN.
          XRL A,#5                      ; IF CALRN=5 IE ## THEN JMP TO PVTX1
          JZ PVTX1                      ; SETS INC OR DEC TXT01.
          MOV A,@R1                     ; READ CALRN.
          XRL A,#6                      ; IF CALRN=6 IE ## THEN JMP TO PVTX2
          JZ PVTX2                      ; SETS INC OR DEC TXT02.
          MOV A,@R1                     ; READ CALRN.
          XRL A,#7                      ; IF CALRN=7 THEN JMP TO TPLMT
          JZ LMTTP                      ; SETS INC OR DEC TPLMT.
          MOV A,@R1                     ; READ CALRN.
          XRL A,#8                      ; IF CALRN=8 THEN JMP TO BTLMT
          JZ LMTBT                      ; SETS INC OR DEC BTLMT.
          JMP SERVD                     ; KEY SERVED.
ZECAL:    MOV R7,#DVMNO-1               ; IF NOT THEN LIMIT DISPLAY TO 3
          MOV R4,#DVMNO-1               ; AS DJNZ LOSES R7 VALUE R4 TEMP STORAGE
          MOV A,#ZERMP                  ; SET ACC TO ZERMP 85-4=81
          MOV R2,A                      ; SET R2 TO POLARITY POSITION OF ZERMP.
          ADD A,#DVMNO                  ; ADD DVMNO TO GET LOCATION OF UNITS PLACE.
          MOV R5,A                      ; LOAD MAP LOCATION IN R5 IN UNITS PLACE.
          MOV R1,A                      ; LOAD MAP LOCATION IN R1 IN UNITS PLACE.
          CALL MPSET                    ; INCREMET ZERMP IF < AND > KEYS ARE PRESSED & CALRN=2
          JMP RMPSR                     ; KEY SERVED IN RAMP UP MODE.
FSCAL:    MOV R1,#HICAL                 ; SET R1 TO LOC HI CAL WHICH WILL BE INC-DEC BY BYSET
          CALL WDSET                    ; THIS INC DEC HICAL AND HICUL.
          JMP RMPSR                     ; KEY SERVED IN RAMP UP MODE.
DPCAL:    MOV R1,#DPSET                 ; SET R1 TO LOC DPSET WHICH WILL BE INC-DEC BY DPSET
          CALL DNSET                    ; SETS DSPNO INC AND DEC OR NO DP.
          JMP SERVD                     ; KEY SERVED.
PVTX1:    MOV R1,#TXT01                 ; SET R1 TO LOC TXT01 WHICH WILL BE INC-DEC BY DPSET
          CALL BYSET                    ; SETS HEX 00 TO FF INC AND DEC.
          JMP RMPSR                     ; KEY SERVED IN RAMP UP MODE.
PVTX2:    MOV R1,#TXT02                 ; SET R1 TO LOC TXT02 WHICH WILL BE INC-DEC BY DPSET
          CALL BYSET                    ; SETS HEX 00 TO FF INC AND DEC.
          JMP RMPSR                     ; KEY SERVED IN RAMP UP MODE.
LMTTP:    MOV R1,#TPLMT                 ; SET R1 TO LOC TPLMT WHICH WILL BE INC-DEC BY DCSET 1-9
          CALL DCSET                    ; SETS INC AND DEC .
          JMP SERVD                     ; KEY SERVED.
LMTBT:    MOV R1,#BTLMT                 ; SET R1 TO LOC BTLMT WHICH WILL BE INC-DEC BY DCSET 1-9
          CALL DCSET                    ; SETS INC AND DEC .
          JMP SERVD                     ; KEY SERVED.
RMPSR:    CALL RMPST                    ; CALL RAMP SERVED ROT.
          JMP KYRET                     ; JUMP OVER.
SERVD:    CALL SERVT                    ; CALL NORM SERV.
KYRET:    RET                           ; RETURN TO ILOOP.
                                        ;
          ORG 0800H                     ;
                                        ;
MAPAL:    MOV R0,#DISPL                 ; LIGHT UP LEDS 8NOS AS REQUIRED BY KEYPRESS.
          MOV A,@R0                     ; READ LOC DISPL.
          ANL A,#SEGCD                  ; 0FH AND TO LOSE UPPER NIBBLE.
          ADD A,#LEDCD                  ; ADD TO ACC ADDR LEDCD
          MOVP3 A,@A                    ; FETCH CODE FROM TABLE ADDR BY ACC
          XRL A,#SKORA                  ; RESTORE CODE TO LOGIC.
          MOV R0,#OPSP1                 ; SET R0 TO LOC OPSP1 IN RAM. 105
          ORL A,@R0                     ; READ IT 00000000B IF OFF 00100000B IF ON SET IN CNTRL.
          INC R0                        ; SET R0 TO LOC OPSP2 IN RAM. 106
          ORL A,@R0                     ; READ IT 00000000B IF OFF 01000000B IF ON SET IN CNTRL.
          MOV R0,#PRGRN                 ; SELECT LOC 107 STORING PROG/RUN STATUS.
          ORL A,@R0                     ; READ IT 00000000B IF RUN 10000000B IN PROG MODE.
          MOV R1,A                      ; SAVE CODE IN R1.
          MOV R0,#CALRN                 ; SET LOACTION CALRN > 0 TO 00000001B.
          MOV A,@R0                     ; READ LOC CALRN FOR PRESENT REQ FOR DISPLAY.
          JNZ CALON                     ; IF NZ THE CAL IS ON.
          CLR A                         ; SET ACC 0 CAL OF CODE=0.
          JMP CALOF                     ; IF NZ THEN CAL IS OF.
CALON:    MOV A,#1                      ; SET ACC TO BIN 00000001B
CALOF:    ORL A,R1                      ; ADD CODE SAVED IN R1 TO CAL CODE.
          XRL A,#SKORA                  ; RESTORE LOGIC TO CODE
          MOV R1,#DSPMP+2               ; 63-9+2=56 THIS LIGHTS THE LED ROW.
          MOV @R1,A                     ; WRITE ORED DATA TO DSPMP+1 LED LINE.
          MOV A,@R0                     ; READ LOC CALRN FOR PRESENT REQ FOR DISPLAY.
          JNZ CALLP                     ; IF CALRN SET > 1 DISPLAY CALRN ALPHABETS.
          MOV R1,#DSPMP+3               ; 63-9+3=57 THIS LIGHTS THE B ROW.
          MOV R0,#DISPL                 ; CHECK DISPL SETTING 0-PV,1-L1,2-D1,3-L2,4-D2.
          MOV A,@R0                     ; READ LOC DISPL FOR PRESENT REQ FOR DISPLAY.
          ANL A,#SEGCD                  ; 0FH AND TO LOSE UPPER NIBBLE.
          ADD A,#ALPHD                  ; ADD TO ACC ADDR ALPHD
          MOVP3 A,@A                    ; FETCH CODE FROM TABLE ADDR BY ACC
          MOV @R1,A                     ; PUT REQUIRED CODE IN DSPMP
          INC R1                        ; GET TO FIRST 2 DSP SET A.
          MOV A,@R0                     ; READ LOC DISPL FOR PRESENT REQ FOR DISPLAY.
          ANL A,#SEGCD                  ; 0FH AND TO LOSE UPPER NIBBLE.
          ADD A,#ALPHD                  ; ADD TO ACC ADDR ALPHD
          ADD A,#5                      ; ADD 5 FOR GETTING CODE OF SECOND DIGIT.
          MOVP3 A,@A                    ; FETCH CODE FROM TABLE ADDR BY ACC
          MOV @R1,A                     ; PUT REQUIRED CODE IN DSPMP
          MOV R0,#DISPL                 ; NZ IMPLIES DISPL ABOVE VALID JUMPOVER.
          MOV A,@R0                     ; READ DISPL
          JNZ MAPRT                     ; DISPL NZ JUMPOVER.
          MOV R0,#PRGRN                 ; IF DISPL=0 IT COMES HERE PRGRN IS 1 DISPLAY PR
          MOV A,@R0                     ; READ PRGRN
          JNZ PRGDS                     ; PR DISPLAY.
          JMP TXTDS                     ; IF PRGRN=0 & DISPL=0 THEN DISPLAY TXT01,02 IN B & A.
PRGDS:    DEC R1                        ; GET TO FIRST 1 DSP SET B.
          MOV A,#PRGCD                  ; MOV TO ACC ADDR PRGCD
          MOVP3 A,@A                    ; FETCH CODE FROM TABLE ADDR BY ACC
          MOV @R1,A                     ; PUT REQUIRED CODE IN DSPMP
          INC R1                        ; GET TO FIRST 2 DSP SET A.
          MOV A,#PRGCD                  ; MOV TO ACC ADDR PRGCD
          ADD A,#1                      ; ADD 1 FOR GETTING CODE OF SECOND DIGIT.
          MOVP3 A,@A                    ; FETCH CODE FROM TABLE ADDR BY ACC
          MOV @R1,A                     ; PUT REQUIRED CODE IN DSPMP
          JMP MAPRT                     ; JUMP OVER.
CALLP:    MOV R1,#DSPMP+3               ; 63-9+3=57 THIS LIGHTS THE B ROW.
          MOV A,@R0                     ; READ LOC CALRN FOR PRESENT REQ FOR DISPLAY.
          ANL A,#SEGCD                  ; 0FH AND TO LOSE UPPER NIBBLE.
          ADD A,#CALCD                  ; ADD TO ACC ADDR CALCD
          MOVP3 A,@A                    ; FETCH CODE FROM TABLE ADDR BY ACC
          MOV @R1,A                     ; PUT REQUIRED CODE IN DSPMP
          INC R1                        ; GET TO FIRST 2 DSP SET A.
          MOV A,@R0                     ; READ LOC CALRN FOR PRESENT REQ FOR DISPLAY.
          ANL A,#SEGCD                  ; 0FH AND TO LOSE UPPER NIBBLE.
          ADD A,#CALCD                  ; ADD TO ACC ADDR CALCD
          ADD A,#9                      ; ADD 9 FOR GETTING CODE OF SECOND DIGIT.
          MOVP3 A,@A                    ; FETCH CODE FROM TABLE ADDR BY ACC
          MOV @R1,A                     ; PUT REQUIRED CODE IN DSPMP
          MOV A,@R0                     ; READ LOC CALRN FOR PRESENT REQ FOR DISPLAY.
          XRL A,#5                      ; PVT01 SETTING.
          JZ TXTBL                      ; DISPLAY BLINKING PV TEXT IN AB DSPLY.
          MOV A,@R0                     ; READ LOC CALRN FOR PRESENT REQ FOR DISPLAY.
          XRL A,#6                      ; PVT02 SETTING.
          JZ TXTBL                      ; DISPLAY BLINKING PV TEXT IN AB DSPLY.
          MOV A,@R0                     ; READ LOC CALRN FOR PRESENT REQ FOR DISPLAY.
          XRL A,#7                      ; TOPCL SETTING.
          JZ TOPCL                      ; DISPLAY BLINKING PV TEXT IN AB DSPLY.
          MOV A,@R0                     ; READ LOC CALRN FOR PRESENT REQ FOR DISPLAY.
          XRL A,#8                      ; BOTCL SETTING.
          JZ BOTCL                      ; DISPLAY BLINKING PV TEXT IN AB DSPLY.
          JMP MAPRT                     ; JUMP OVER.
TOPCL:    DEC R1                        ; GET TO FIRST 1 DSP SET B.
          MOV @R1,#11110011B XOR SKORA  ; SET B DSP TO H.
          INC R1                        ; GET TO FIRST 2 DSP SET A.
          MOV R0,#TPLMT                 ; SET R0 TO RAM TPLMT
          MOV A,@R0                     ; READ MAX LIMIT IN K POSITION.
          SEL MB0                       ; SEL MEMBANK 0.
          CALL ENSGM                    ; ENCODE ACC VALUE LOWER NIBBLE TO 7SEG VALUE.
          SEL MB1                       ; SEL MEMBANK 1.
          MOV @R1,A                     ; PUT ENCODED VALUE IN A POSITION OF AB DSPLY.
          JMP MAPRT                     ; JUMP OVER.
BOTCL:    DEC R1                        ; GET TO FIRST 1 DSP SET B.
          MOV @R1,#10100110B XOR SKORA  ; SET B DSP TO H.
          INC R1                        ; GET TO FIRST 2 DSP SET A.
          MOV R0,#BTLMT                 ; SET R0 TO RAM TPLMT
          MOV A,@R0                     ; READ MAX LIMIT IN K POSITION.
          SEL MB0                       ; SEL MEMBANK 0.
          CALL ENSGM                    ; ENCODE ACC VALUE LOWER NIBBLE TO 7SEG VALUE.
          SEL MB1                       ; SEL MEMBANK 1.
          MOV @R1,A                     ; PUT ENCODED VALUE IN A POSITION OF AB DSPLY.
          JMP MAPRT                     ; JUMP OVER.
TXTBL:    MOV R0,#BLINK                 ; SET R0 TO RAM LOCATION BLINK
          MOV A,@R0                     ; READ BLINK 00 OR FF.
          JNZ BLING                     ; IF FF DISPLAY AND CPL BLINK.
          JMP BLANG                     ; IFF 00 BLANK AND CPL BLINK.
BLING:    CPL A                         ; 00 TO FF FF TO 00 TO ALTERNATE ON OFF.
          MOV @R0,A                     ; WRITE BACK TO BLINK.
          JMP TXTDS                     ; DISPLAY TXT01,02
BLANG:    CPL A                         ; 00 TO FF FF TO 00 TO ALTERNATE ON OFF.
          MOV @R0,A                     ; WRITE BACK TO BLINK.
          DEC R1                        ; GET TO FIRST 1 DSP SET B.
          MOV @R1,#BLANK XOR SKORA      ; BLANK IT.
          INC R1                        ; GET TO FIRST 2 DSP SET A.
          MOV @R1,#BLANK XOR SKORA      ; BLANK IT.
          JMP MAPRT                     ; JUMP OVER.
TXTDS:    DEC R1                        ; GET TO FIRST 1 DSP SET B.
          MOV R0,#TXT01                 ; SET R0 TO TXT01 LOC.
          MOV A,@R0                     ; READ CHARACTER CODE IN TXT01.
          MOV @R1,A                     ; WRITE INTO DSPLY LOC B.
          INC R1                        ; GET TO FIRST 2 DSP SET A.
          INC R0                        ; SET R0 TO TXT02 LOC.
          MOV A,@R0                     ; READ CHARACTER CODE IN TXT02.
          MOV @R1,A                     ; WRITE INTO DSPLY LOC B.
MAPRT:    RET                           ; MAPIT RETURNS TO ILOOP.
